
'#######################################
'inculde file for RF12-device
'info about RF12 Transceiver:       www.hoprf.com or www.integration.com
'info about using RF12 with Bascom: www.comwebnet.de
'
'Version History
'---------------
'Initial Version: v0.10
'Date: 200711
'Author:  Kurzschluss
'---------------

' ########################################################################
' Wersja nadajnika 1.2 z 11.06.2011
' RFM komend &h8201 cakowicie wyczany
' ########################################################################

'$regfile = "m8def.dat"
$regfile = "m644pdef.dat"
$crystal = 16000000
$baud = 9600

$hwstack = 100
$swstack = 100
$framesize = 100


'deklaracje procedur

Declare Function Rf12_trans(byval Wert As Word) As Word
Declare Sub Rf12_ready

Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 16 , Noss = 1
Spi_cs Alias Portc.5                                        'definiujemy pin wyboru dla ukadu RFM12B
Config Pinc.5 = Output

Spi_sdo Alias Pinb.6                                        'definiujemy pin MISO
Config Pinb.6 = Input
Set Portb.6

Config Pinb.7 = Output
Config Pinb.5 = Output
Config Pinb.4 = Output                                      'ustawiamy wszystkie konieczne piny jako wyjcia

'dezaktywujemy ukad RFM12B
Set Spi_cs
'inicjalizujemy interfejs SPI
Spiinit

'konieczne zmienne

Dim A As Byte
Dim Temp As Word, address as word
Dim Text As String * 32 , Dane(32) As Byte At Text Overlay

Dim Count As Byte


'inicjalizacja ukadu RFM12B
Temp = Rf12_trans(&H80e7)                                   'ustawienie pasma 868MHz, konfiguracja FIFO

Temp = Rf12_trans(&H8208)                                   'Wczenie oscylatora

Temp = Rf12_trans(&Ha640)                                   'ustawienie kanau 0110 0010 0000
'kana w nadajniku i odbiorniku musz by takie same

Temp = Rf12_trans(&Hc647)                                   'ustawienie prdkoci transmisji (musi by takie samo w obu urzdzeniach)

Temp = Rf12_trans(&H94a0)                                   'ustawienie pasma przesyania na 134KHz (szerokie)

Temp = Rf12_trans(&Hc2ac)                                   'wybr filtra cyfrowego, ustawienie duego marginesu bdw

Temp = Rf12_trans(&Hca81)                                   'ustawienie synchronizacji

Temp = Rf12_trans(&Hced4)                                   'ustawienie sowa synchronizacji na &HD4

Temp = Rf12_trans(&Hc483)                                   'ustawienie kontroli czstotliwoci na automatyczne

Temp = Rf12_trans(&H9850)                                   'konfiguracja mocy i modulacji nadajnika

Temp = Rf12_trans(&Hcc17)                                   'konfiguracja sygnaw zegarowych

Temp = Rf12_trans(&He000)                                   'wyczenie timera wewntrznego

Temp = Rf12_trans(&Hc800)                                   'wyczenie trybu oszczdzania energii

Temp = Rf12_trans(&Hc000)                                   'wyczenie detekcji niskiego zasilania

Address = &HD0
Gosub Rf12_rxaddr
'powyej ustawilimy swj adres, na ktry bdziemy przyjmowa dane

 Do

    Gosub Rf12_rxdata
    'odbieramy dane
    If Text = "Siemka" Then                                 'jeli dotar do nas interesujcy tekst
      Text = "Slave wita po raz " + Str(count)
      Address = &HD4
      Gosub Rf12_txdata
      'to odsyamy rwnie ciekaw odpowied na adres mastera
      Incr Count
    End If

Loop

End

'*******************************************************************************
'WYSYANIE DANYCH PRZEZ NADAJNIK"
'*******************************************************************************
Rf12_txdata:

  Temp = Rf12_trans(&H8239)                                 ' Konfigurujemy Ukad Do Nawawania
  Waitms 5                                                  'czekamy na zmian konfiguracji ukadu
  Rf12_ready                                                'po wysaniu kadej komendy czekamy a ukad wykona nasze polecenia
  Temp = Rf12_trans(&Hb8aa)                                 'nadajemy 3 krotnie bajt synchronizacyjny o wartoci AA (B8 to komenda wysyajca dane)
  Rf12_ready
  Temp = Rf12_trans(&Hb8aa)
  Rf12_ready
  Temp = Rf12_trans(&Hb8aa)
  Rf12_ready
  Temp = Rf12_trans(&Hb82d)                                 'nadajemy stay bajt synchronizacji o wartoci 2D
  Rf12_ready
  Temp = &HB800 + Address
  Temp = Rf12_trans(temp)                                   'nadajemy definiowany bajt synchronizacyjny (taki jak w konfiguracji odbiornika)
  'bajt ten moemy wykorzysta do adresowania kilku ukadw nadajcych na tej samej czstotliwoci
  Rf12_ready

   A = 0
   Do
      Incr A
        Temp = &HB800 + Dane(a)                             'nadajemy nasze dane dopki nie natrafimy na koniec tekstu (bajt o wartoci 0)
        Temp = Rf12_trans(temp)
        Rf12_ready
        If A > 32 Then Exit Do                              'sprawdzamy czy nie wychodzimy poza zakres
   Loop Until Dane(a) = 0
  'nadajemy 3 krotnie dummy byte
  Temp = Rf12_trans(&Hb8aa)
  Rf12_ready
  Temp = Rf12_trans(&Hb8aa)
  Rf12_ready
  Temp = Rf12_trans(&Hb8aa)
  Rf12_ready
  'i wyczamy nadajnik
   Temp = Rf12_trans(&H8201)
Return

'*******************************************************************************
'ODBIERANIE
'*******************************************************************************
 Rf12_rxdata:
  Temp = Rf12_trans(&H82c9)                                 'konfigurujemy ukad do odbierania danych
  Waitms 5                                                  'czekamy, a bdzie gotowy
  Temp = Rf12_trans(&Hca81)                                 '2 ponisze komendy powoduj zresetowanie bufora odbiorczego
  Temp = Rf12_trans(&Hca83)                                 '
  A = 0
  Do
   Incr A
      Rf12_ready
      Temp = Rf12_trans(&Hb000)                             'odbieramy dane (uywamy komendy B0) dopki nie natrafimy na ich koniec sygnalizowany bajtem o wartoci 0
      Dane(a) = Temp
      If A > 32 Then Exit Do                                'sprawdzimy czy nie wychodzimy poza zakres
  Loop Until Dane(a) = 0

  Temp = Rf12_trans(&H8201)                                 'wyczamy odbiornik
Return

Rf12_rxaddr:

  Temp = &HCE00 + Address
  Temp = Rf12_trans(temp)

Return

'*******************************************************************************
'Komunikacja z ukadem RFM12B
'*******************************************************************************
Function Rf12_trans(byval Wert As Word) As Word
  Local Lowbyte As Byte
  Local Highbyte As Byte

  Lowbyte = Wert And 255
  Shift Wert , Right , 8
  Reset Spi_cs

  Highbyte = Spimove(wert)
  Lowbyte = Spimove(lowbyte)
  Set Spi_cs

  Temp = Highbyte * 256
  Temp = Temp + Lowbyte
  Rf12_trans = Temp
End Function

'*******************************************************************************
Sub Rf12_ready
   Local Count As Byte
   Count = 0
  Reset Spi_cs
  Waitms 1
  While Spi_sdo = 0
   Waitus 100
   Incr Count
   If Count = 0 Then Exit While
  Wend
End Sub
'*******************************************************************************