$nocompile

'-------------------------------------------------------------------------------
'                         Config_MMCSD_HC.INC
'               Config File for MMC/SD/SDHC Flash Cards Driver
'        (c) 2003-2009 , MCS Electronics / Vgel Franz Josef
'-------------------------------------------------------------------------------
' Place MMCSD_HC.LIB in the LIB-Path of BASCOM-AVR installation
'
' you can vary MMC_CS on HW-SPI and all pins on SOFT-SPI, check settings
'
' ========== Start of user definable range =====================================
'
' Declare here you SPI-Mode
' using HW-SPI:     cMMC_Soft = 0
Const Hardware_spi = 0
' not using HW_SPI: cMMC_Soft = 1
Const Software_spi = 1

'poniej deklarujemy, ze uywamy sprztowego SPI
'mozemy te wpisa Software_spi, aby uywa programowego SPI na dowolnych pinach procesora (konfiguracja poniej)
Const Cmmc_soft = Hardware_spi

'Poczenie:
'Karta <> procesor (w nawiasach piny uyte przeze mnie w programie)
'DAT3 - CS   (PB4)
'DI   - MOSI (PB5)
'DAT0 - MISO (PB6)
'CLK  - SCK  (PB7)

#if Cmmc_soft = 0

' --------- Konfiguracja dla sprztowego SPI ------------------------------------

  ' Definiujemy pin, ktry bdzie pinem CS dla karty
  Config Pinb.4 = Output
  Mmc_cs Alias Portb.4
  Set Mmc_cs

  ' jeli powyej zdefiniowany pin CS nie jest taki sam jak pin SS sprztowego moduu SPI to i tak (eby wszystko dziaao poprawnie) musimy
  ' skonfigurowa sprztowy pin SS - w przeciwnym razie modu sprztowy nie bdzie dziaa poprawnie
  Config Pinb.4 = Output
  Spi_ss Alias Portb.4
  Set Spi_ss


  ' Konfigurujemy sprztowy modu SPI do komunikacji z kart SD
  Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
  'i inicjalizujemy prac moduu
  Spiinit

' --------- Koniec konfiguracji dla sprztowego SPI -----------------------------

#else

' --------- Konfiguracja dla programowego SPI (moemy uy dowolnych pinw) ----

  ' Chip Select Pin  => DAT3
  Config Pinb.4 = Output
  Mmc_cs Alias Portb.4
  Set Mmc_cs

  ' MOSI - Pin  => DI
  Config Pinb.5 = Output
  Set Pinb.5
  Mmc_portmosi Alias Portb
  Bmmc_mosi Alias 5

  ' MISO - Pin  => DAT0
  Config Pinb.6 = Input
  Mmc_portmiso Alias Pinb
  Bmmc_miso Alias 6

  ' SCK - Pin  =>CLK
  Config Pinb.7 = Output
  Set Pinb.7
  Mmc_portsck Alias Portb
  Bmmc_sck Alias 7

' --------- Koniec komfiguracji dla programowego SPI ---------------------------

#endif

' ========== Koniec konfiguracji - poniej nic nie zmieniamy ===================

'tu moemy podejrze niektre kody statusu karty i bdw
'==== Variables For Application ================================================
Dim Mmcsd_cardtype As Byte                                  ' Information about the type of the Card
'   0 can't init the Card
'   1 MMC
'   2 SDSC Spec. 1.x
'   4 SDSC Spec. 2.0 or later
'  12 SDHC Spec. 2.0 or later

Dim Gbdriveerror As Byte                                    ' General Driver Error register
' Values see Error-Codes
'===============================================================================



' ==== Variables for Debug =====================================================
' You can remove remarks(') if you want check this variables in your application
Dim Gbdrivestatusreg As Byte                                ' Driver save here Card response
' Dim gbDriveErrorReg as Byte at GbdriveStatusReg overlay     '
' Dim gbDriveLastCommand as Byte                              ' Driver save here Last Command to Card
Dim Gbdrivedebug As Byte
' Dim MMCSD_Try As Byte                                        ' how often driver tried to initialized the card
'===============================================================================


'==== Driver internal variables ================================================
' You can remove remarks(') if you want check this variables in your application
' Dim _mmcsd_timer1 As Word
' Dim _mmcsd_timer2 As Word
'===============================================================================



' Error-Codes
Const Cperrdrivenotpresent = &HE0
Const Cperrdrivenotsupported = &HE1
Const Cperrdrivenotinitialized = &HE2

Const Cperrdrivecmdnotaccepted = &HE6
Const Cperrdrivenodata = &HE7

Const Cperrdriveinit1 = &HE9
Const Cperrdriveinit2 = &HEA
Const Cperrdriveinit3 = &HEB
Const Cperrdriveinit4 = &HEC
Const Cperrdriveinit5 = &HED
Const Cperrdriveinit6 = &HEE

Const Cperrdriveread1 = &HF1
Const Cperrdriveread2 = &HF2

Const Cperrdrivewrite1 = &HF5
Const Cperrdrivewrite2 = &HF6
Const Cperrdrivewrite3 = &HF7
Const Cperrdrivewrite4 = &HF8



$lib "MMCSD_HC.LIB"
$external _mmc
' Init the Card
Gbdriveerror = Driveinit()

'(
'tu znajduj si dodatkowe funkcje do odczytu niektrych informacji o karcie SD, ale nie bdziemy ich uywa
'wic wyczymy ich kompilacj, aby zaoszczdzi miejsca w pamieci procesora.
' you can remark/remove following two Code-lines, if you dont't use MMCSD_GetSize()
$external Mmcsd_getsize
Declare Function Mmcsd_getsize() As Long


' you can remark/remove following two Code-lines, if you dont't use MMCSD_GetCSD()
' write result of function to an array of 16 Bytes
$external Mmcsd_getcsd
Declare Function Mmcsd_getcsd() As Byte


' you can remark/remove following two Code-lines, if you dont't use MMCSD_GetCID()
' write result of function to an array of 16 Bytes
$external Mmcsd_getcid
Declare Function Mmcsd_getcid() As Byte


' you can remark/remove following two Code-lines, if you dont't use MMCSD_GetOCR()
' write result of function to an array of 4 Bytes
$external Mmcsd_getocr
Declare Function Mmcsd_getocr() As Byte


' you can remark/remove following two Code-lines, if you dont't use MMCSD_GetSDStat
' write result of function to an array of 64 Bytes
$external Sd_getsd_status
Declare Function Sd_getsd_status() As Byte

' check the usage of the above functions in the sample MMCSD_Analysis.bas
' check also the MMC and SD Specification for the content of the registers CSD, CID, OCR and SDStat
')